﻿// ==================================================================
// Function TUTORIUM for Demonstrating the Matrix Classes
//          --------
// C++ - MATRIX OAjects and Methods for Tensor/Matrix Calculus
// ==================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Advanced teaching and study program - Commercial use not permitted.
// The author assumes no liaAility for incompleteness and errors!
// Version:  2023
// Compiler: C++ 
// ==================================================================
// TUTORIUM: Erzeugung von Matrixobjekten und
//           Handhabung von elementaren ueberladenen Operatoren 
// =============== Include Files ====================================
#include "pch.h"                          // pre-compiled header file
// -------------
// #include "Matrizen.h" 
            // aAstract Matrices class                   MATRIZEN
// #include "Matrix.h" 
            // 4-dimensional douAle rectangle matrices   MATRIX
// #include "Vektor.h" 
            // 1-dimensional vectors                     VEKTOR
// #include "delta_Matrix.h"  
            // delta-matrices                            delta_MATRIX
// #include "e_Matrix.h"   
            // e-matrices                                e_MATRIX
// #include "intMatrix.h" 
            // 4-dimensional integer matrices            intMATRIX
// #include "intVektor.h"  
            // 1-dimensional integer vectors             intVEKTOR
// ==================================================================
//  Tutorium für WWW 
int TUTORIUM(ofstream& outFILE, ifstream& inFILE)
{                         // outFILE logs the data input 
                          // inFile provides the data input
    // --------------------------------------------------------------
    // ofstream outFILE;
    // string output = "Output file";
    // outFILE.open(output, ios::app);
    // cout << "Output file: " << Output << endl << endl;
    // ==============================================================
    bool ERROR;
    ERROR = false;
    // ERROR = true;
    if (ERROR) std::cout << "Error = " << ERROR << endl;
    // ======================== TUTORIUM ============================
cout << endl
     << "1.1 - Matrixobjekte und elementare Operatoren" << endl
     << "=============================================" << endl << endl;
    // C-Feld mit Werten vorbelegen
    // ----------------------------
    double F[10] = { 0,1,2,3,4,5,6,7,8,9};
    cout << "C-Vektor F(10) =";
    for (int j = 0; j < 10; j++) cout << " " << F[j];                   // ausdrucken
    cout << endl << endl;
    //
    // Erzeugen einer statischen Instanz der Klasse VEKTOR mittels Konstruktor
    // -----------------------------------------------------------------------
    VEKTOR V(F,6);                      // (1x6)-Vektor V wird mit F vorbelegt
    cout << "(1x6)-Vektor V := F = " << V << endl;     // ueberladener Operator '<<'
    //
    // Erzeugen einer statischen Instanz der Klasse MATRIX mittels Konstruktor
    // ------------------------------------------------------------------------
    MATRIX M(3,3);                      // (3x3)-Matrix, Zuweisung von V an M
    // hier Ausnahme: Typumwandlung (casting) durch M := V zur Demonstration     
    M = V;                              // ueberladener Operator '='
    cout << "(3x3)-Matrix M := V = " << M << endl;                       // ausdrucken
    // 
    // Erzeugen einer statischen Instanz der Klasse delta_MATRIX mittels Konstruktor
    // -----------------------------------------------------------------------------
    delta_MATRIX d(2,2);                // (2x2)-delta-Matrix
    cout << "(2x2)-delta-Matrix d = " << d << endl;                      // ausdrucken
    //
    // Erzeugen einer statischen Instanz der Klasse MATRIX mittels Konstruktor
    MATRIX A(2, 2);                      // (2x2)-Matrix
    cout << "(2x2)-Matrix A = " << A << endl;                            // ausdrucken
    // ================================================================
    cout << endl
         << "1.2 - Addition und Subtraktion" << endl
         << "==============================" << endl << endl;
    // 
    // Matrix M wird durch die Mitgiedsfunktion dimension temporaer verkleinert! 
    //                         --------------------------  
    // Matrizen-Addition M(i,k) + A(i,k)
    // ---------------------------------
    A = M.dimension(2,2) + d;           // ueberladener Operator '+'
    cout << "Matrix A = M + d = " << A << endl;                         // ausdrucken
    cout << "(3x3)-Matrix im Original erhalten: M = " << M << endl;     // ausdrucken
    //        
    // Matrizen-Subtraktion A(i,k) - d(i,k)
    // ------------------------------------
    A = A - d;                          // ueberladener Operator '-' 
    cout << "Matrix A = A - d = " << A << endl;                         // ausdrucken
    //
    // Determinante von Matrix A
    // -------------------------
    double S;
    S = A.determinante(2);
    cout << "Determinante det(A) = " << S << endl << endl;
    //
    // Freigeben der dynamischen Matrix M
    // ----------------------------------
    // delete& M;                       // loeschen mittels Destruktor '~'  
    // ================================================================
    cout << endl
                << "2.1 - Kartesische Basis und Matrix-Vektor-Multiplikationen"
        << endl << "=========================================================="
        << endl << endl;
    // ----------------------------------------------------------------------------- 
    // => Vektoren v(i) werden intern als Matrizen v(0,i) mit N(0) = 1 behandelt,
    //    um Skalarprodukte einfach bilden zu koennen!
    // ------------------------------------------------------------------------------
    // Erzeugen von drei kartesischen Bezugsvektoren  
    VEKTOR e0(3), e1(3), e2(3);                // (1x3)-Vektoren
    e0(0) = 1.0;  e1(1) = 1.0;
    cout << "(1x3)-Vektor e0 = " << e0 << endl;                        // ausdrucken
    cout << "(1x3)-Vektor e1 = " << e1 << endl;                        // ausdrucken
    //
    // Erzeugen von zwei physikalischen Vektoren  
    VEKTOR v0(3), v1(3);                       // (1x3)-Vektoren 
    v0(0) = 6.0; v0(1) = 2.0;                     
    cout << "(1x3)-Vektor v0 = " << v0 << endl;                         // ausdrucken
    v1(0) = 1.0; v1(1) = 2.0;      
    cout << "(1x3)-Vektor v1 = " << v1 << endl;                         // ausdrucken
    //
    // Berechnung des Skalarproduktes s = v0(0,s) * v1(0,s)
    // ---------------------------------------------------- 
    double s;
    s = v0 * v1;
    cout << "Skalar s = e0 * e1 = " << s << endl << endl;               // ausdrucken
    //
    // Berechnung des dyadischen Produktes  M(i,k) = v0(i) * v1(k)
    // ----------------------------------------------------------- 
    M = v0.dimension(3) * v1.dimension(3);
    cout << "Dyadisches Produkt M = v0 * v1 = " << M << endl;           // ausdrucken
    //
    // Berechnung des Vektorproduktes e2(0,i) = e(ikl) * e0(0,k) * e1(0,l)
    // -------------------------------------------------------------------
    // Erzeugen einer statischen Instanz der Klasse e_MATRIX mittels Konstruktor
    e_MATRIX e(3,3,3);                  // (3x3x3)-e-Matrix
    cout << "(3x3x3)-e-Matrix e = " << e << endl;                       // ausdrucken
    // verkettete Multiplikation ohne die Mitgliedsfunktion dimension 
    e2 = (e * e0) * e1;
    cout << "(1x3)-Vektor e2 = e0 x e1 = " << e2 << endl;               // ausdrucken
    //
    // allgemeines Matrizen-Produkt C(i,k,l,m) = A(i,s,k) * B(l,s,m)
    // -------------------------------------------------------------
    // => mittels der Mitgliedsfunktion M.dimension(N{i}, N{k}, N{l}, N{m})
    //    können temporaer
    // => Matrizen M um einen 0-Index erweitertert werden
    //    M(s,k) =: M(0,s,k) mit N{0} = 1,
    // => Matrizenindizes M(i,k,l) zusammengefasst werden
    //    M(i,k,s,l) =: M(IK,s,l)  mit N{IK} = N{i} * N{k},
    // => um den Summationsindex s in die mittlere Position zu bringen !
    // -----------------------------------------------------------------
    cout << "(2x2)-Matrix A = " << A << endl;                           // ausdrucken
    //
    // Erzeugen der Matrizen C und B
    MATRIX C(2,2), B(2,2);              // (2x2)-Matrizen
    B = d;
    B(0,1) = 0.5;
    cout << "(2x2)-Matrix B = " << B << endl;                          // ausdrucken
    // 
    // Matrizenmultiplikation C(i,k) = A(i,s) * B(0,s,k)
    // --------------------------------------------------
    C = A * B.dimension(1, 2, 2);
    cout << "(2x2)-Matrix C = A * B  = " << C << endl;                  // ausdrucken
    // 
    // Matrizenmultiplikation C(i,k) = A(0,s,i) * B(0,s,k)
    // ----------------------------------------------------
    C = A.dimension(1,2,2) * B.dimension(1, 2, 2);
    cout << "(2x2)-Matrix C = A(T) * B  = " << C << endl;               // ausdrucken
    //
    // Grassmann-Identitaet
    // --------------------
    // delta-Matrix(i,k,l,m) = e-Matrix(i,k,s) * e-Matrix(l,m,s)
    // Erzeugen einer statischen Instanz der Klasse MATRIX mittels Konstruktor
    MATRIX D4(3,3,3,3);                 // (3x3x3x3)-Matrix         
    D4 = e.dimension(3 * 3, 3) * e.dimension(3 * 3, 3);
    cout << "(3x3x3x3)-delta-Matrix 4. Ordnung D4(i,k,l,m) = " << D4 << endl; // ausdrucken
    //
    // Probe
    // -----
    // Erzeugen einer dynamischen Instanz der Klasse delta_MATRIX mittels Konstruktor
    delta_MATRIX& d4 = *new delta_MATRIX(3, 3, 3, 3);   // (3x3x3x3)-delta-Matrix 
    //*** cout << "Probe: (3x3x3x3)-delta-Matrix 4. Ordnung d4(i,k,l,m) = " << d4 << endl; // ausdrucken
    //
    // Freigabe der dynamischen Matrix d4
    delete& d4;                       // loeschen mittels Destruktor '~'
    // ====================================================================
    cout << endl
        << "3.1 - Basisvektoren und Metriken im Euklidischen Raum" << endl
        << "=====================================================" << endl
        << endl;
    // ----------------------------------------------------------------------- 
    // kovariante Basisvektoren
    VEKTOR g0(3), g1(3);
    g0 = v0;                             //.dimension(3);
    g1 = v1;                             //.dimension(3);
    //
    // Erzeugen einer dynamischen Instanz der Klasse BASIS mittels Konstruktor
    // -----------------------------------------------------------------------
    //
    BASIS& basis = *new BASIS(g0,g1);
    //
    // kovariante Basisvektoren
    // ------------------------
    MATRIX kov_basis(3,2);              // (3x2)-Matrix
    kov_basis = basis.kovariante_basis();
    cout << "kovariante Basisvektoren: (3x2)-Matrix kov_Basis = " << kov_basis << endl; // ausdrucken
    //
    // kovariante Metrik
    // -----------------
    MATRIX kov_metrik(2,2);             // (2x2)-Matrix 
    double g = basis.kovariante_metrik(kov_metrik);
    cout << "kovariante Metrik: (2x2)-Matrix kov_metrik = " << kov_metrik << endl;               // ausdrucken
    cout << "kovariante Metrik: Determinante g = " << g << endl << endl;                        // ausdrucken
    //
    // kontravariante Metrik
    // ---------------------
    MATRIX kontra_metrik(2,2);          // (2x2)-Matrix
    basis.kontravariante_metrik(kontra_metrik);
    cout << "kontravariante Metrik: (2x2)-Matrix kontra_metrik " << kontra_metrik << endl;       // ausdrucken
    //
    // Probe -> Einheitsmatrix
    // -----------------------
    MATRIX& Einh = *new MATRIX(2, 2);
    Einh = kov_metrik.dimension(1,2,2) * kontra_metrik.dimension(1,2,2);
    cout << "Probe: Einheitsmatrix = kov_metrix * kontra_metrix " << Einh << endl; // ausdrucken
    //
    // kontravariante Basisvektoren
    // ----------------------------
    MATRIX kontra_basis(3, 2);           // (3x2)-Matrix
    kontra_basis = basis.kontravariante_basis();
    cout << "kontravariante Basisvektoren: (3x2)-Matrix kontra_Basis = " << kontra_basis << endl; // ausdrucken
    //
    // Probe -> Einheitsmatrix
    // -----------------------
    Einh = *new MATRIX(2, 2);         // dynamiche (2x2)-Matrix
    Einh = kov_basis.dimension(1,3,2) * kontra_basis.dimension(1,3,2);
    cout << "Probe: Einheitsmatrix = kov_basis * kontra_basis " << Einh << endl; // ausdrucken
    // 
    // Freigaben von dynamischen Objekten
    // ----------------------------------
    delete& basis;                      // loeschen mittels Destruktor '~'
    delete& Einh;                       // loeschen mittels Destruktor '~'
    // ================================================================
    cout << endl
        << "4.1 - Tensor-Transformationen" << endl
        << "=============================" << endl << endl;
    // ----------------------------------------------------------------
    VEKTOR v(3);                                 // (1x3)-Vektor
    // Vektor im kartesischen Bezugssystem e0-e1-e2
    v(0) = 0.0;    v(1) = 5.0;
    cout << "kartesisches System: Vektor v(i) = " << v << endl;                   // ausdrucken
    //
    // Vektor v(i) ins schiefwinklige Bezugssystem g0-g1 transformieren
    // ----------------------------------------------------------------
    VEKTOR v_kov(2);                                    // (1x2)-Vektor
    // v_kov(0,alpha) = kov_basis(0,i,alpha) * v(0,i)
    //
    v_kov = kov_basis.dimension(1,3,2) * v;
    cout << "schiefwinkliges System: kovarianter Vektor v(alpha) = " << v_kov << endl;  // ausdrucken
    //
    // Vektor v_schief(alpha) vom schiefwinkligen ins kartesische System zurücktransformieren
    // --------------------------------------------------------------------------------------
    // v(0,i) = kontra_basis(i,alpha) * v_kov(0,alpha)  
    //
    v = kontra_basis * v_kov;
    cout << "Probe: kartesisches System: Vektor v(i) = " << v << endl;             // ausdrucken
    //
    // Tensor 4.Stufe transformieren
    // -----------------------------
    // Elastiztaestensor E im kartesischen Bezugssystem e0-e1 aufbauen
    // C-Feld mit fiktiven Werten zeilenweise (!) vorbelegen
    // ---------------------------------------------------------------
    double F16[16] = { 1,0,0,0, 0,0.5,0.5,0, 0, 0.5, 0.5, 0, 0,0,0,1 };
    // Erzeugen einer statischen Instanz der Klasse MATRIX mittels Konstruktor
    // -----------------------------------------------------------------------
    MATRIX E(F16,2, 2, 2, 2);                     // (2x2x2x2)-Matrix wird mit F16 vorbelegt
    cout << "(2x2x2x2)-Elastizitaetstensor E := F16 = " << E << endl;          // ausdrucken
    MATRIX E_kontra(2, 2, 2, 2);                  // (2x2x2x2)-Matrix
    // 
    // Tensor E(i,k,l,m) ins schiefwinklige Bezugssystem g0-g1 transformieren
    // -----------------------------------------------------------------------
    // kontravariante Basis auf (2x2)-Matrix kuerzen - dritte Zeile streichen
    kontra_basis = kontra_basis.untermatrix_heraus(0,2,0,2);
    cout << "kontravariante Basisvektoren: (2x2)-Matrix kontra_Basis = "
                                      << kontra_basis.dimension(2,2) << endl; // ausdrucken
    //
    // E_kontra(i,k, gamma,delta) =
    //   (E(IK,l,m) * kontra_basis(1,l,gamma)) * kontra_basis(0,m,delta)
    //                                                      mit N{IK} = N{i}*N{k}
    //
    E_kontra =        E.dimension(2 * 2, 2, 2) * kontra_basis.dimension(1, 2, 2);
    E_kontra = E_kontra.dimension(2 * 2, 2, 2) * kontra_basis.dimension(1, 2, 2);
    //*** cout << "schiefwinkliges System: Tensor E_kontra(i,k,gamma,delta) = "
    //***      << E_kontra << endl;                                            // ausdrucken
    //    
    // E_kontra(alpha,beta, gamma,delta) =
    //   kontra_basis(0,i,alpha) * (kontra_basis(0,k,beta) * E_kontra(i,k,GD)) 
    //                                                       mit N{GD} = N{gamma}*N{delta}
    //
    E_kontra = kontra_basis.dimension(1, 2, 2) * E_kontra.dimension(2, 2, 2 * 2);
    E_kontra = kontra_basis.dimension(1, 2, 2) * E_kontra.dimension(2, 2, 2 * 2);
    cout << "schiefwinkliges System: Tensor E_kontra(alpha,beta,gamma,delta) = "
         << E_kontra << endl;                                                  // ausdrucken
    //
    // kontravarianten (2x2)-Levi-Civita-Tensor mittels Klasse e_MATRIX erzeugen
    // -------------------------------------------------------------------------
    e_MATRIX epsilon_Tensor(2, 2, 1.0/sqrt(g));
    cout << "schiefwinkliges System: kontravarianter epsilon-Tensor = " 
                                                 << epsilon_Tensor << endl;    // ausdrucken
    // 
    // =======================================================
    std::cout << "Ende Tutorium" << endl;
    std::cout << "=============" << endl;
    //
    std::cout << "Pause:" << endl;
    // ###########################
    char c;
    std::cin >> c;                              outFILE << c << endl;
    // ==============================================================
    return 0;
}
